/*->c.dbox */

#include <stdafx.h>
#include "resource.h"



#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <time.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "flex.h"
#include "sprite.h"
#include "transform.h"
#include "bbc.h"
#include "akbd.h"


#include "wos.h"
#include "err.h"
#include "task.h"
#include "poll.h"
#include "temp.h"
#include "scrap.h"
#include "fsx.h"
#include "timex.h"
#include "etc.h"
#include "config.h"
#include "save.h"
#include "bf.h"
#include "key.h"
#include "crc.h"
#include "pane.h"
#include "bits.h"
#include "colour.h"
#include "redraw.h"
#include "deb.h"


#include "constants.h"

#include "reslink.h"
#include "mlo.h"



#include "dbox.h"




/****************************************************************************/





static int mphandle;




typedef struct speakerstr
{
 int state;
 int paused;
 int over;
 int timesofar;
 int maxtime;

 int set5icon;
 int set10icon;
 int set15icon;
 int pauseicon;
 int restarticon;
 int infoicon;
 int redrawicon;
 int clearicon;
 int nameicon;

} speakerstr;


#define MAXSPEAKER  8

static int nspeakers=MAXSPEAKER;

#define SPEAKERNAMELEN 32

static char speakernames[MAXSPEAKER][SPEAKERNAMELEN];


#define SCLR  0
#define SRUN0 1
#define SRUN1 2
#define SRUN2 3
#define SRUN3 4
#define SRUN4 5


#define ALLCLEARICON 27

static speakerstr speaker[MAXSPEAKER]=
{
 // state, paused,over,timesofar,maxtime,set5,set10,set15,pauseicon,restarticon,infoicon,redraw,clear,name,
    SCLR,       1 ,  1 ,  0      ,   1,    29,   30,  31,     32,       33,        34,     38,    28,   26,
    SCLR,       1 ,  1 ,  0      ,   1,    42,   43,  44,     45,       46,        47,     49,    41,   40,
    SCLR,       1 ,  1 ,  0      ,   1,    53,   54,  55,     56,       57,        58,     60,    52,   51,
    SCLR,       1 ,  1 ,  0      ,   1,    64,   65,  66,     67,       68,        69,     71,    63,   62,
    SCLR,       1 ,  1 ,  0      ,   1,    75,   76,  77,     78,       79,        80,     82,    74,   73,
    SCLR,       1 ,  1 ,  0      ,   1,    86,   87,  88,     89,       90,        91,     93,    85,   84,


};


static os_error * syncdiscsclose(int w,int userhandle);

static os_error * updateslider(int icon,int stathandle);


static os_error * startpolling(int w);

static int speakpollmonotonic;


static void pause(int delay)
{
 delay+=clock();
 while(clock()<delay);

}


static os_error * speakerinfo(int s,int w)
{
 os_error * err;
 int        left;
 int        secs;
 int        max;

 err=NULL;

 max=speaker[s].maxtime/6000;

 if(speaker[s].state==SCLR)  err=writeiconc(w,speaker[s].infoicon,"");
 else
 if(speaker[s].paused) err=writeiconfc(w,speaker[s].infoicon,"%d: Paused",max);
 else
 if(speaker[s].over) err=writeiconfc(w,speaker[s].infoicon,"%d: Please stop",max);
 else
 {
  left=(speaker[s].maxtime-speaker[s].timesofar);


  if(left>30*100)
  {
   left=left/100;
   left=((left+4)/5)*5;
   secs=left % 60;

//  dprintf(5,"left %d secs %d",left,secs);

   if(secs==0)
   {
    if(left<120) err=writeiconfc(w,speaker[s].infoicon,"%d: <1 minute left",max);
    else         err=writeiconfc(w,speaker[s].infoicon,"%d: <%d minutes left",max,left/60);
   }
   else          err=writeiconfc(w,speaker[s].infoicon,"%d: <%d:%02d left",max,left/60,secs);
  }
  else
  {
   left=left/100;

   if(left==28 || left==27 || left==26 || left==20 || left==19 ||
      left==18 || left==17 || left==16 || left==10 || left==9 ||
      left==8  || left==7  || left==6) err=writeiconfc(w,speaker[s].infoicon,"%d: Please close",max);
   else
   if(left<=5)                              err=writeiconfc(w,speaker[s].infoicon,"%d: Please stop",max);
   else
   if(left==30 || left==29)  err=writeiconfc(w,speaker[s].infoicon,"%d: <30 secs left",max);
   else
   if(left==25 || left==24 || left==23 || left==22 || left==21)
                                                err=writeiconfc(w,speaker[s].infoicon,"%d: <25 secs left",max);
   else
   if(left==15 || left==14 || left==13 || left==12 || left==11)
                                                err=writeiconfc(w,speaker[s].infoicon,"%d: <15 secs left",max);
   else err=writeiconfc(w,speaker[s].infoicon,"something wrong %d",left);
  }
 }
 return(err);
}




static void speakpoll(int userhandle)
{
 int i;
 int delta;
 int timeleft;

 delta=monotonic()-speakpollmonotonic;

 for(i=0;i<MAXSPEAKER;i++)
 {
  if((!speaker[i].paused) && (!speaker[i].over) && (speaker[i].state!=SCLR))
  {
   if(delta)
   {
    speaker[i].timesofar+=delta;

    if(speaker[i].timesofar>=speaker[i].maxtime)
    {
     speaker[i].over=1;
     shadeiconst(userhandle,speaker[i].pauseicon,1);
     shadeiconst(userhandle,speaker[i].restarticon,1);
    }

    updateslider(speaker[i].redrawicon,userhandle);

//   dprintf(0,"delta %d sofar %d max %d",delta,speaker[i].timesofar,speaker[i].maxtime);

    speakerinfo(i,userhandle);

    timeleft=speaker[i].maxtime-speaker[i].timesofar;
    timeleft=timeleft/100;


    if(timeleft<=60 && speaker[i].state==SRUN0)
    {
     bbc_vdu(7);
     speaker[i].state=SRUN1;
    }

    if(timeleft<=30 && speaker[i].state==SRUN1)
    {
     bbc_vdu(7);
     pause(100);
     bbc_vdu(7);
     speaker[i].state=SRUN2;
    }


    if(timeleft<=10 && speaker[i].state==SRUN2)
    {
     bbc_vdu(7);
     pause(100);
     bbc_vdu(7);
     speaker[i].state=SRUN3;
    }

    if(timeleft<=5 && speaker[i].state==SRUN3)
    {
     bbc_vdu(7);
     speaker[i].state=SRUN4;
    }

//    if(timeleft<=0)
//    {
//     bbc_vdu(7);
//     bbc_vdu(7);
//    }
   }

   if(!speaker[i].over) startpolling(userhandle);
  }
 }

 speakpollmonotonic+=delta;
}


static int speakpollcount;

static void speakpollevent(int userhandle)
{
 speakpollcount=0;
 speakpoll(userhandle);
}


static os_error * startpolling(int w)
{

 if(speakpollcount==0)
 {
  speakpollcount=1;
  return(addscheduledevent(speakpollevent,w,500));
 }

 return(NULL);
}





static os_error * pausespeaker(int s,int w)
{
 os_error * err;

 err=NULL;

 if((!speaker[s].paused) && (!speaker[s].over) && (speaker[s].state!=SCLR))
 {
  speakpoll(w);
  speaker[s].paused=1;
  err=speakerinfo(s,w);
  if(!err) err=updateslider(speaker[s].redrawicon,w);
  shadeiconst(w,speaker[s].pauseicon,1);
  shadeiconst(w,speaker[s].restarticon,0);
 }

 return(err);
}


static os_error * pauseothers(int s,int w)
{
 os_error *  err;
 int         i;
             
 err=NULL;

 for(i=0;i<MAXSPEAKER;i++)
 {
  if(i!=s) pausespeaker(i,w);
 }

 return(err);
}


static os_error * restartspeaker(int s,int w)
{
 os_error * err;

 err=NULL;

 if(speaker[s].state!=SCLR && speaker[s].paused==1 && (!speaker[s].over))
 {
  speakpoll(w);
  pauseothers(s,w);
  speaker[s].paused=0;
  err=speakerinfo(s,w);
  if(!err) err=updateslider(speaker[s].redrawicon,w);
  shadeiconst(w,speaker[s].pauseicon,0);
  shadeiconst(w,speaker[s].restarticon,1);
  startpolling(w);
 }

 return(err);
}



static os_error * speakerstart(int s,int w,int maxtime)
{
 os_error * err;
                
 err=NULL;

 pauseothers(s,w);
 speakpoll(w);
 speaker[s].state=SRUN0;
 speaker[s].paused=0;
 speaker[s].over=0;
 speaker[s].timesofar=0;
 speaker[s].maxtime=maxtime;
 speakerinfo(s,w);
 updateslider(speaker[s].redrawicon,w);
 startpolling(w);
 shadeiconst(w,speaker[s].pauseicon,0);
 shadeiconst(w,speaker[s].restarticon,1);

 return(err);
}

// B=41.1

#define SLIDERCOLOUR

static os_error * predrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error  * err;
 int         i;

 err=NULL;

 while(more)
 {
  for(i=0;i<MAXSPEAKER;i++)
  {
   redrawslider(redrawstr,speaker[i].redrawicon,handle,((speaker[i].paused||speaker[i].over)?WIMPGREY4:WIMPDBLUE)/*|(WIMPGREY1<<8)*/,(speaker[i].state==SCLR)?0:speaker[i].timesofar,speaker[i].maxtime);
  }
  err=wimp_get_rectangle(redrawstr,&more);
 }

 return(err);
}


static os_error * predraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) err=predrawsub(handle,&redrawstr,more);
 return(err);
 USE(userhandle);
}



static os_error * updateslider(int icon,int stathandle)
{
 os_error      * err;
// int             more;
// wimp_icon       isblock;
// wimp_redrawstr  rblock;


 err=wimp_set_icon_state((wimp_w)stathandle,icon,(wimp_iconflags)0,(wimp_iconflags)0);
/*
 err=wimp_get_icon_info(stathandle,icon,&isblock);

 rblock.w=stathandle;
 rblock.box=isblock.box;
  
 if(!err) err=wimp_update_wind(&rblock,&more);
 if(!err) err=predrawsub(stathandle,&rblock,more);
*/
 return(err);
}


static os_error * speakerclear(int s,int w)
{
 os_error * err;

 speaker[s].state=SCLR;
 speakerinfo(s,w);
 shadeiconst(w,speaker[s].pauseicon,1);
 shadeiconst(w,speaker[s].restarticon,1);
 err=updateslider(speaker[s].redrawicon,w);

 return(err);
}


static os_error * speakerclearall(int w)
{
 os_error * err;
 int        i;

 err=NULL;

 for(i=0;i<MAXSPEAKER;i++)
 {
  err=speakerclear(i,w);
 }

 return(err);
}





static os_error * syncdiscsicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        i;


 err=NULL;

 for(i=0;i<MAXSPEAKER;i++)
 {
  if(m->i==speaker[i].pauseicon)
  {
   pausespeaker(i,handle);
   break;
  }

  if(m->i==speaker[i].restarticon)
  {
   restartspeaker(i,handle);
   break;
  }

  if(m->i==speaker[i].set5icon)
  {
   speakerstart(i,handle,(5*60)*100);
   break;
  }

  if(m->i==speaker[i].set10icon)
  {
   speakerstart(i,handle,10*60*100);
   break;
  }

  if(m->i==speaker[i].set15icon)
  {
   speakerstart(i,handle,15*60*100);
   break;
  }

  if(m->i==speaker[i].clearicon)
  {
   speakerclear(i,handle);
  }
 }
 
 if(m->i==ALLCLEARICON) speakerclearall(handle);

 return(err);

 USE(userhandle);
}



static os_error * syncdiscskey(int handle,int userhandle,int icon,int * key)
{
 os_error    * err;
 int           ch;
 wimp_mousestr m;

 err=NULL;

 ch=*key;

 if(ch==RETURN)
 {
  *key=-1;
  m.i=0;
  err=syncdiscsicon(handle,userhandle,&m);
 }
 else
 if(ch==ESCAPE)
 {
  *key=-1;
  m.i=1;
  err=syncdiscsicon(handle,userhandle,&m);
 }

 return(err);

 USE(icon);
}



static os_error * savenames(int w)
{
 int    i;
 char * p;

 if(w)
 {
  for(i=0;i<MAXSPEAKER;i++)
  {
   iconaddr(w,speaker[i].nameicon,&p);
   xstrncpy(speakernames[i],p,SPEAKERNAMELEN);
  }
 }

 return(NULL);
}


static os_error * syncdiscsclose(int w,int userhandle)
{
 os_error * err;

 savenames(w);

 remkeyevent(syncdiscskey,mphandle,0);
 remclickevent(syncdiscsicon,mphandle,0);
 remcloseevent(syncdiscsclose,mphandle,0);
 remredrawevent(predraw,mphandle,0);
  
 err=closedown(&mphandle);

 pollquit(0);

 return(err);

 USE(userhandle);
 USE(w);
}





os_error * openspeaktime(void)
{
 os_error * err;
 int        i;

 if(mphandle) err=forward(mphandle,0,NULL);
 else
 {
  err=createwindow(TSPEAKTIME,&mphandle);
  if(!err)
  {
   addkeyevent(syncdiscskey,mphandle,0);
   addclickevent(syncdiscsicon,mphandle,0);
   addcloseevent(syncdiscsclose,mphandle,0);
   addredrawevent(predraw,mphandle,0);

   for(i=0;i<MAXSPEAKER;i++)
   {
    speakerinfo(i,mphandle);
    writeicon(mphandle,speaker[i].nameicon,speakernames[i]);
    shadeiconst(mphandle,speaker[i].pauseicon,1);
    shadeiconst(mphandle,speaker[i].restarticon,1);
   }

   popup(mphandle,0);
  }
 }
 return(err);
}

static conarraystr speakerarray=
{
 NULL,
 "S32",

};



static contag contable[]=
{
 "Speakers",    CONINT,  &nspeakers,     NULL,  NULL,
 "Name",        CONARRAY,NULL,           NULL,  NULL,

 NULL,0,NULL,NULL,NULL
};


static conlink configlink=
{
 "SpeakerTime",
 NULL,
 NULL
};





static char * registrypath="HKEY_CURRENT_USER\\Software\\David Pilling\\SpeakerTime";


os_error * configsave(void)
{
 savenames(mphandle);


 return(saveconfigregistry(registrypath));
// return(saveconfig(path));
}


os_error * configinit(void)
{
 os_error  * err;

 contable[1].address=(void*)speakernames;
 contable[1].data.array=&speakerarray;
 speakerarray.y=&nspeakers;

 err=addcontable(contable,&configlink);

// if(!err) err=loadconfig(path);

 if(!err)
 {
  err=loadconfigregistry(registrypath);

  cprintf("load config speakers %d",nspeakers);
  cprintf("n %s %s",speakernames[0],speakernames[1]);

  if(err) err=NULL; // allow for registry entries not existing
 }


 return(err);
}





